<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XSelfProvisionRemove StructType
 * @subpackage Structs
 */
class XSelfProvisionRemove extends AbstractStructBase
{
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - default: English United States
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * Constructor method for XSelfProvisionRemove
     * @uses XSelfProvisionRemove::setName()
     * @param string $name
     */
    public function __construct($name = 'English United States')
    {
        $this
            ->setName($name);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @uses XUserLocale::valueIsValid()
     * @uses XUserLocale::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $name
     * @return XSelfProvisionRemove
     */
    public function setName($name = 'English United States')
    {
        // validation for constraint: enumeration
        if (!XUserLocale::valueIsValid($name)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $name, implode(', ', XUserLocale::getValidValues())), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return XSelfProvisionRemove
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
